%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
%
% Written (W) 2005-2009 Gunnar Raetsch, Gabriele Schweikert, Jonas Behr, Soeren Sonnenburg, Alexander Zien, Georg Zeller, Andre Noll, Cheng Soon Ong, Petra Philips
% Copyright (C) 2005-2009 Max Planck Society and Fraunhofer Institute FIRST 
%
function [blocks,res]=predict(PAR, blocks)
% [blocks,res]=predict(PAR, blocks)

%addpath(PAR.FN.source_directory)
%paths

%if nargin<3 || strcmp(set,'test')
%  testset=1;
%else
%  testset=0;
%end
%
%%PAR.submit=1;
%if ~isfield(PAR, 'iteration')||isempty(PAR.iteration) 
%  PAR.iteration = find_iteration(PAR);
%end
%if testset&&(~isfield(PAR, 'fn_pred')||isempty(PAR.fn_pred))
%  PAR.fn_pred = [PAR.FN.output_lsl.fn_pred 'iteration_' num2str(PAR.iteration) '/'];
%  PAR.fn_blocks = PAR.FN.input_lsl.fn_val_blocks;
%elseif ~testset&&(~isfield(PAR, 'fn_pred')||isempty(PAR.fn_pred))
%  PAR.fn_pred = [PAR.FN.output_lsl.fn_pred 'trainset_iteration_' num2str(PAR.iteration) '/'];
%  PAR.fn_blocks = PAR.FN.input_lsl.fn_training_blocks;
%end

PAR.model = fix_model(PAR.model) ;

if nargin<2
  blocks = load_struct(PAR.fn_blocks, 'blocks');
  blocks = fix_blocks(blocks, PAR.model) ;
end

unix(sprintf('mkdir -p %s',PAR.fn_pred));
blocks = pred_path(PAR, blocks) ;

res = [] ;

if isfield(PAR, 'evaluate') && ~PAR.evaluate
  return
end

res = evaluate(PAR.fn_blocks, PAR.fn_pred, PAR.model)
fprintf('save results to %sresults.mat\n',PAR.fn_pred) 
save(sprintf('%sresults.mat',PAR.fn_pred), 'res', '-v7');

%printf('Nucleotide level accuracy:\n') ;
%print_struct(1, res.cds_nucleotides) ;

fprintf('Exon level accuracy:\n')
print_struct(1, res.cds_exons) ;

fprintf('Transcript level accuracy:\n')
print_struct(1, res.cds_transcripts) ;

fprintf('\n\n\n') ;

res

return

genome_info = init_genome(PAR.FN.input.fn_genome_config);

for j=1:length(blocks)
  load(sprintf('%s_viterbi_block%i',PAR.fn_pred,blocks(j).id),'pred');
  blocks(j).pred = pred;
  clear pred
end

if 1
  load(PAR.FN.output.fn_genes_merged,'genes');
else
  load(PAR.FN.output.fn_genes_anno,'genes');
  for j=1:length(genes)
    genes(j).anno_id = genes(j).id;
    if strcmp(genes(j).transcripts{1},'dummy')
      genes(j).mask_on = 1;
    end
%    genes(j).mask_on = max(genes(j).transcript_status)<1;
  end
end
  res_all.cds_nucleotides.num_obsv =0; 
  res_all.cds_nucleotides.num_pred =0; 
  res_all.cds_nucleotides.num_corr =0; 
  res_all.cds_exons.num_obsv       =0; 
  res_all.cds_exons.num_pred       =0; 
  res_all.cds_exons.num_corr       =0; 
  res_all.cds_transcripts.num_obsv =0; 
  res_all.cds_transcripts.num_pred =0; 
  res_all.cds_transcripts.num_corr =0; 

for j=1:length(blocks)
  if ~isempty(blocks(j).pred.genes{1})
    genes_pred = blocks2genes(blocks(j),PAR.model,'pred',genome_info);
  else
    genes_pred = init_genes(1);
  end
  for k=1:length(genes_pred)
    genes_pred(k).id = k;
    %if isempty(genes_pred(j).exons{1})
    %  warning('exons field empty');
    %end
    %if isempty(genes_pred(j).cds_exons{1})
    %  warning('exons field empty');
    %end
  end
  [res,map] = evaluate_predictions(blocks(j),genes,genes_pred,genome_info,0);
  res_all = addresults(res_all, res);
end

% Compute sensitivity and specificity
%res_all.nucleotides.SN     = res_all.nucleotides.num_corr      /res_all.nucleotides.num_obsv;
%res_all.nucleotides.SP     = res_all.nucleotides.num_corr      /res_all.nucleotides.num_pred;

res_all.cds_nucleotides.SN = res_all.cds_nucleotides.num_corr  /res_all.cds_nucleotides.num_obsv;
res_all.cds_nucleotides.SP = res_all.cds_nucleotides.num_corr  /res_all.cds_nucleotides.num_pred;

res_all.cds_exons.SN       = res_all.cds_exons.num_corr        /res_all.cds_exons.num_obsv;
res_all.cds_exons.SP       = res_all.cds_exons.num_corr        /res_all.cds_exons.num_pred;

%res_all.exons.SN           = res_all.exons.num_corr            /res_all.exons.num_obsv;
%res_all.exons.SP           = res_all.exons.num_corr            /res_all.exons.num_pred;
%
%res_all.transcripts.SN     = res_all.transcripts.num_corr      /res_all.transcripts.num_obsv;
%res_all.transcripts.SP     = res_all.transcripts.num_corr      /res_all.transcripts.num_pred;
%
res_all.cds_transcripts.SN = res_all.cds_transcripts.num_corr  /res_all.cds_transcripts.num_obsv;
res_all.cds_transcripts.SP = res_all.cds_transcripts.num_corr  /res_all.cds_transcripts.num_pred;

res = res_all;

ret = 0%res.cds_transcripts.mean_SNSP;

save(sprintf('%sresults.mat',PAR.fn_pred), 'res', 'ret', '-v7');

return

function res = addresults(r1, r2)

  res.cds_nucleotides.num_obsv 	= r1.cds_nucleotides.num_obsv	+r2.cds_nucleotides.num_obsv;
  res.cds_nucleotides.num_pred 	= r1.cds_nucleotides.num_pred	+r2.cds_nucleotides.num_pred;
  res.cds_nucleotides.num_corr 	= r1.cds_nucleotides.num_corr	+r2.cds_nucleotides.num_corr;
  res.cds_exons.num_obsv 	= r1.cds_exons.num_obsv		+r2.cds_exons.num_obsv;
  res.cds_exons.num_pred 	= r1.cds_exons.num_pred		+r2.cds_exons.num_pred;
  res.cds_exons.num_corr 	= r1.cds_exons.num_corr		+r2.cds_exons.num_corr;
  res.cds_transcripts.num_obsv 	= r1.cds_transcripts.num_obsv	+r2.cds_transcripts.num_obsv;
  res.cds_transcripts.num_pred 	= r1.cds_transcripts.num_pred	+r2.cds_transcripts.num_pred;
  res.cds_transcripts.num_corr 	= r1.cds_transcripts.num_corr	+r2.cds_transcripts.num_corr;
return


function iteration = find_iteration(PAR)

iteration = 1 ;
while (1)
  fname = sprintf('%s_iteration%i.mat', PAR.FN.output_lsl.fn_train,iteration) ;
  if ~fexist(fname), iteration=iteration-1 ; break ; end ;
  iteration=iteration+1 ;
end ;
return

return

function [run_locally] = rproc_policy(task, genome_info, param)
% run_locally = rproc_policy(task, genome_info)
% determines based on genome properties, whether the task to be solved 
%   should use subjobs or should run sequentially

global USE_SGE ;

if ~USE_SGE
  run_locally = 1 ;
  return ;
end ;

if ~isempty(genome_info),
  num_contigs = length(genome_info.contig_names) ;
  total_size = 0 ;
else
  num_contigs = 0 ;
  total_size = 0 ;
end ;

if isequal(task, 'gff2anno') 
  % param = number of genes
  if num_contigs>25 || num_contigs<=2,
    run_locally = 1 ;
  else
    run_locally = 0 ;
  end ;
elseif isequal(task, 'signal_wrapper') || isequal(task, 'content_wrapper'),
  run_locally = 0 ;
elseif isequal(task, 'signal_train:pos') || isequal(task, 'content_train:pos'),
  run_locally = 1 ;
elseif isequal(task, 'signal_train:train') || isequal(task, 'content_train:train'),
  run_locally = 0 ;
elseif isequal(task, 'signal_train:eval') || isequal(task, 'content_train:eval'),
  run_locally = 1 ;
elseif isequal(task, 'signal_train:conf') || isequal(task, 'content_train:conf'),
  run_locally = 1 ;
elseif isequal(task, 'signal_train:predict') || isequal(task, 'content_train:predict'),
  run_locally = 1 ;
elseif isequal(task, 'signal_train:save') || isequal(task, 'content_train:save'),
  run_locally = 1 ;
elseif isequal(task, 'signal_predict:pos') || isequal(task, 'content_predict:pos')
  run_locally = 1 ;
elseif isequal(task, 'signal_predict:predict') || isequal(task, 'content_predict:predict')
  if num_contigs>=3 && num_contigs<=20,
    run_locally = 0 ;
  else
    run_locally = 1 ;
  end ;
elseif isequal(task, 'signal_predict:conf') %|| isequal(task, 'content_predict:conf')
  run_locally = 1 ;
elseif isequal(task, 'signal_predict:concat') || isequal(task, 'content_predict:concat')
  run_locally = 1 ;
elseif isequal(task, 'signal_predict:save') || isequal(task, 'content_predict:save')
  run_locally = 1 ;
elseif isequal(task, 'gene_train') 
  run_locally = 0 ;  
elseif isequal(task, 'gene_predict') 
  if num_contigs>=3 && num_contigs<=300,
    run_locally = 0 ;
  else
    run_locally = 1 ;
  end ;
elseif isequal(task, 'mgene_train') 
  run_locally = 1 ;  
elseif isequal(task, 'mgene_predict') 
  run_locally = 1 ;    
elseif isequal(task, 'train_path:gen_paths') 
  if param>=3,
    run_locally = 0 ;    
  else
    run_locally = 1 ;    
  end ;
elseif isequal(task, 'pred_path:gen_paths') 
  run_locally = 0 ;
else
  fprintf('did not find rproc policy for task %s\n', task) ;  
  run_locally = 1 ;
end ;

return

function [mem_mb, time_min, opts] = rproc_memtime_policy(function_name, data_size, options, verbosity) ;
% [mem_mb, resubmit,options] = rproc_mem_policy(function_name, data_size, options) ;

if nargin<4,
  verbosity=1 ;
end ;
if nargin<3,
  options=struct ;
end ;
  
mem_mb = 2000 ;
time_min = 1000 ;

resubmit = 3 ;
opts = options ;
opts.resubmit = resubmit ;
opts.mem_req_resubmit = [5000 7000 16000] ;
opts.time_req_resubmit = [2000 3000 5000] ;
opts.data_size = data_size ;
opts.priority = 50 ;

if isequal(function_name, 'load_and_train'),

elseif isequal(function_name, 'load_and_predict'),

elseif isequal(function_name, 'concat_genomewide_predictons_helper'),

elseif isequal(function_name, 'Out2Confhelper'),

elseif isequal(function_name, 'save_label_files_starter'),

elseif isequal(function_name, 'save_examples'),

elseif length(function_name)>=length('signal_wrapper') && isequal(function_name(1:length('signal_wrapper')), 'signal_wrapper')

  if isequal(function_name, 'signal_wrapper:tss') || isequal(function_name, 'signal_wrapper:cleave')
    mem_mb = 4000 ;
    time_min = 2000 ;
    opts.resubmit = 2 ;
    opts.mem_req_resubmit = [7000 16000] ;
    opts.time_req_resubmit = [5000 8000] ;
  end ;

elseif isequal(function_name, 'gen_paths'),

  mem_mb = 500 ;
  time_min = 30 ;
  
  if abs(data_size)>100000,
    mem_mb = mem_mb*2 ;
  end ;
  
  resubmit = 2 ;
  opts = options ;
  opts.resubmit = resubmit ;
  opts.mem_req_resubmit = [mem_mb*2 mem_mb*4] ;
  opts.time_req_resubmit = [300 1000] ;
  opts.data_size = data_size ;
  
elseif isequal(function_name, 'predict'),
  
  mem_mb = 4000 ;
  time_min = 500 ;
  
  resubmit = 0 ;
  opts = options ;
  opts.resubmit = resubmit ;
  opts.mem_req_resubmit = [] ;
  opts.time_req_resubmit = [] ;
  opts.data_size = data_size ;

end ;


if verbosity>=1
  if ~isempty(data_size),
    fprintf('rproc_memtime_policy for %s with data_size=%i: %i Mb and %i minutes\n', ...
            function_name, data_size(1), mem_mb, time_min) ;
  else
    fprintf('rproc_memtime_policy for %s: %i Mb and %i minutes\n', ...
            function_name, mem_mb, time_min) ;
  end ;
end ;


return

function [blocks,PAR,P] = pred_path(PAR, blocks)
% [blocks,PAR,P] = pred_path(PAR [, blocks])
%
%
check_split = 0 ;

if ~isfield(PAR, 'fn_log')
  fid=1;
PAR.evaluate = 0;
else  
  fid = fopen( sprintf('%spred.txt',PAR.fn_log),'a+') ;
end
fprintf(fid,'\n\npred_path \n');
fprintf(fid,'date: %s\n',date);
%fprintf(fid,'\n start \n');

if ~isfield(PAR, 'gen_paths_func')
  PAR.gen_paths_func = 'gen_paths' ; 
else
  PAR.gen_paths_func 
end ;

%% parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~isfield(PAR, 'fn_gene_predictor')
  if ~isfield(PAR, 'iteration')
    iteration = 1 ;
    while (1)
      fname = sprintf('%s_iteration%i.mat', PAR.FN.output_lsl.fn_train,iteration) ;
      if ~fexist(fname), iteration=iteration-1; break ; end 
      iteration=iteration+1 ;
    end ;
  else
    iteration = PAR.iteration;
  end ;
  fname = sprintf('%s_iteration%i.mat', PAR.FN.output_lsl.fn_train,iteration) ;
  fprintf('Loading iteration %i\n', iteration) ;
  if check_split,
    load(fname, 'QP', 'TRAIN_PAR', 'num_examples');
    TRAIN_PAR.model = fix_model(TRAIN_PAR.model) ;
    blocks_train = load_struct(sprintf('%s_iteration%i_blocks.mat', PAR.FN.output_lsl.fn_train,iteration)) ;
    blocks_train = fix_blocks(blocks_train, TRAIN_PAR.model) ;
    idx = [blocks_train.id] ;
    clear blocks_train
  else
    load(fname, 'QP', 'TRAIN_PAR', 'num_examples');
    TRAIN_PAR.model = fix_model(TRAIN_PAR.model) ;
  end ;
else 
  load(PAR.fn_gene_predictor, 'QP', 'TRAIN_PAR', 'num_examples');
  TRAIN_PAR.model = fix_model(TRAIN_PAR.model) ;
end

%% load data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if nargin<2
  load(PAR.fn_blocks, 'blocks') ;
  blocks = fix_blocks(blocks, TRAIN_PAR.model) ;
end
if isfield(PAR,'fn_splits')
  load(PAR.fn_splits, 'blocks_split') ; 
  block_idx = [blocks_split{PAR.pred_split_idx}] ;
  if check_split
    if ~isempty(intersect(idx, block_idx))
      disp('test and training are overlapping') ;
      keyboard
      disp('correcting indices') ;
      block_idx = setdiff([blocks_split{:}], idx) ;
    end ;
  end ;
  blocks = blocks(block_idx) ;
end
fprintf('Predicting on %i blocks\n', length(blocks)) ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if isfield(TRAIN_PAR.model, 'use_conservation') && TRAIN_PAR.model.use_conservation 
  disp('Converting conservation levels') ;
  for id = 1:length(blocks),
    blocks(id).genestr_conserv = conservation2DNA_alphabet(blocks(id).conservation) ;
  end ;  
end ;

if isfield(PAR.LSL.method, 'add_lin_feat') && PAR.LSL.method.add_lin_feat
  assert(iscell(PAR.LSL.method.add_feat_fun))
  assert(iscell(PAR.FN.input_lsl.fn_lin_feat_data))
  assert(length(PAR.FN.input_lsl.fn_lin_feat_data)==length(PAR.LSL.method.add_feat_fun))
  for feat_type=1:length(PAR.LSL.method.add_feat_fun)
    fprintf('load linear features with function: %s from file: %s\n', PAR.LSL.method.add_feat_fun{feat_type}, PAR.FN.input_lsl.fn_lin_feat_data{feat_type}) ;
    blocks = feval(PAR.LSL.method.add_feat_fun{feat_type}, blocks, PAR.FN.input_lsl.fn_lin_feat_data{feat_type}, 80);
  end
end
%if isfield(PAR,'use_tiling')&&PAR.use_tiling&& ~isfield(blocks,'intensities')
%  blocks=add_intensities2blocks(blocks,PAR.FN.input_lsl.fn_tiling_data,80);
%end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%if isfield(PAR, 'use_gc') && ~PAR.use_gc
%  disp('Removing GC splice sites') ;
%  for id = 1:length(blocks),
%    idx=find(blocks(id).genestr(blocks(id).details.pos.don+1)=='T') ;
%    blocks(id).details.pos.don=blocks(id).details.pos.don(idx) ;
%    blocks(id).details.score.don=blocks(id).details.score.don(idx) ;
%    blocks(id).details.output.don=blocks(id).details.output.don(idx) ;
%  end ;  
%end ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% avoid multiple loading of the big constant parameter file
global GLOBAL_cPAR ;
GLOBAL_cPAR=[] ;

cPAR=[] ;
cPAR.model = TRAIN_PAR.model ;

if isfield(PAR.model, 'intron_list'),
  cPAR.model.intron_list = PAR.model.intron_list ;
end ;

%cPAR.blocks_fname = ['~/' tempname '.mat'] ;
%cPAR.blocks = blocks ;
[xis, cPAR.parameters] = res2param(QP.res, num_examples, TRAIN_PAR.model, ...
                                   QP, 0, TRAIN_PAR.weight_names);
cPAR.parameters_fields = fieldnames(cPAR.parameters) ;

%% ADD offset to tss transitions to enhance sensitivity
if isfield(PAR.LSL.method,'tss_offset')
  error('not implemented') ;
  %cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==cPAR.model.state_ids.tss-1)) = cPAR.parameters.transitions(find(cPAR.model.a_trans(2,:)==cPAR.model.state_ids.tss-1))+PAR.LSL.method.tss_offset ;
end
P=[] ;
P.cPAR_fname = sprintf('~/tmp/%i-%1.10f.mat', round(rand(1)*1e8), now) ;
assert(~fexist(P.cPAR_fname)) ;
save(P.cPAR_fname, 'cPAR', '-v7') ;

%save_struct(cPAR.blocks_fname, blocks) ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

P.viterbi_nbest = 1;

run_locally = rproc_policy('pred_path:gen_paths', [], length(blocks)) ;

[engine, environment] = determine_engine() ;

num = 0 ; model = TRAIN_PAR.model ;
jobinfo = rproc_empty(1) ;
if run_locally,
  fprintf(fid,'\nComputing %i dynamic programs ...',length(blocks));
else
  fprintf(fid,'\nSubmitting %i dynamic programs ...',length(blocks));
end ;
for block_id = 1:length(blocks),

  %idx = find(blocks(block_id).truth(1).segments(:,3)~=model.segments.intergenic) ;
  %max_len = max(500, max(blocks(block_id).truth(1).segments(idx,2)- ...
  %                       blocks(block_id).truth(1).segments(idx,1))) ;
  %max_len = max_len*1.2+1000 
  %P.max_len = max_len ;
  fprintf('%i ... ', block_id) ;

  P.block_id = block_id ;
  P.block = blocks(block_id) ;
  P.fn_save = sprintf('%s_viterbi_block%i.mat', PAR.fn_pred, blocks(block_id).id);
  system(sprintf('rm -f %s', P.fn_save)) ;

  %if fexist(P.fn_save),
    %continue; 
  %end 
  P.prediction = 1 ;
  P.FN = PAR.FN;
  options = PAR.RPROC.options;
  options.identifier = ['G'  num2str(block_id)] ;
  %options.start_dir =  fileparts(which(PAR.gen_paths_func));
  options.express = 0;
  options.verbosity = 2 ;

  if ~run_locally,
    [mem_req, time_req, opts]=rproc_memtime_policy('gen_paths', length(P.block.seq), options) ;
    num = num+1 ;
    if ~isfield(options, 'immediately_bg') || options.immediately_bg==0,
      if PAR.RPROC.exm_per_batch==1,
        jobinfo(num) = rproc(PAR.gen_paths_func, P, mem_req, opts, time_req) ;
      else
        jobinfo(num) = rproc_create(PAR.gen_paths_func, P, mem_req, opts, time_req) ;
      end ;
    else
      jobinfo(num) = rproc(PAR.gen_paths_func, P, mem_req, opts, time_req) ;
    end ;
  else
    pred = feval(PAR.gen_paths_func, P) ;
  end ;
end
fprintf('Done.\n') ;

if ~run_locally,
  if ~isfield(options, 'immediately_bg') || options.immediately_bg==0,
    if PAR.RPROC.exm_per_batch==1,
        [jobinfo, num_crashed] = rproc_wait(jobinfo, 60, 1, -1, 1);
    else
      [jobinfo, meta_jobinfo] = rproc_submit_batch(jobinfo, PAR.RPROC.exm_per_batch) ;
      [meta_jobinfo,num_crashed] = rproc_wait(meta_jobinfo, 60, 1, -1, 1);
    end ;
  else
    [jobinfo,num_crashed] = rproc_wait(jobinfo, 60, 1, -1, 1);
  end ;
  if num_crashed>0,
    error('%i jobs crashed. Cannot continue.', num_crashed) ;
  end ;
end ;

blocks(1).pred = struct;
for block_id = 1:length(blocks),
  block = blocks(block_id) ;
  while ~fexist(sprintf('%s_viterbi_block%i.mat', PAR.fn_pred, block.id ))
    fprintf('.') ;
    pause(10)
  end
  load(sprintf('%s_viterbi_block%i.mat', PAR.fn_pred, block.id ),'pred');   
  blocks(block_id).prediction = pred; 
end

unix(['rm -f ' P.cPAR_fname]) ;

%save([PAR.fn_pred 'blocks'], 'blocks', 'PAR', 'P') ;
if fid>2
  fclose(fid);
end

return

function x = fexist(filename,gz)
% FEXIST Check if file exists
%        FEXIST('filename') returns:
%        0 if filename does not exist
%        1 if filename exists in the given path

if nargin<2,
  gz=0;
end ;

fd = fopen(filename);
if fd ~= -1
  x = 1;
  fclose(fd);
elseif gz,
  fd = fopen([filename '.gz']);
  if fd~=-1,
    x=1 ;
    fclose(fd) ;
  else
    x=0 ;
  end ;
else
  x = 0;
end

return

function f=separate(str, delim, merge_multiple) ;
% f=separate(str, delimiter, merge_multiple_delimiters) ;
  
if nargin<2, delim=sprintf('\t') ; end ;
if nargin<3, merge_multiple=0 ; end ;
f={} ;
idx=[0 find(str==delim) length(str)+1] ;
if merge_multiple,
  idx2=find(idx(1:end-1)~=idx(2:end)-1) ;
  idx=[idx(idx2) idx(end)] ;
end 
for i=1:length(idx)-1
  f{i}=deblank(str(idx(i)+1:idx(i+1)-1)) ;
end ;

return

function [engine, environment, basedir, mccdir, license_type] = determine_engine() ;
% [engine, environment, basedir, mccdir, license_type] = determine_engine() ;
% 
% returns either 'matlab' or 'octave' in variable engine
% and 'internal' or 'galaxy' in variable environment
% basedir is the directory of the matlab or octave instance
% mccdir is the directory of the matlab compiler (does not yet exist for octave)

global g_license_type ;

if isempty(g_license_type),
  g_license_type = 'academic' ;
end ;
license_type = g_license_type ;

lic=license ;
if ~isequal(lic, 'GNU General Public License'),
  engine='matlab' ;
else
  engine='octave' ;
end ;

environment='internal' ;
if isequal(whoami, 'galaxy'),
  environment='galaxy' ;
end ;

if isequal(engine, 'matlab') && isequal(environment,  'internal'),
  basedir = '/fml/ag-raetsch/share/software/matlab/' ;
elseif isequal(engine, 'matlab') && isequal(environment,  'galaxy'),
  basedir = '/home/galaxy/matlab-7.6/' ;
elseif isequal(engine, 'octave') && isequal(environment,  'internal'),
  basedir = '/fml/ag-raetsch/share/software/octave-3.0.3/' ;
elseif isequal(engine, 'octave') && isequal(environment,  'galaxy'),
  basedir = '/home/galaxy/octave-3.0.4' ;
end ;

if isequal(environment,  'internal'),
  mccdir = '/fml/ag-raetsch/share/software/matlab/' ;
elseif isequal(environment,  'galaxy'),
  mccdir = '/home/galaxy/matlab-7.6/' ;
end ;

return

return

function x = equal(M1, M2)
% EQUAL(M1, M2) tests M1 and M2 for equality
% Function to test whether two matrices are identical
%
% returns 1 if true and 0 if false

x=isequal(M1, M2) 

return

function save_append(fname__, append_flag, varargin)
% save_append(fname__, append_flag, varargin)
%
% octave compatible version of save -append

try,
  if append_flag
    L__=load(fname__) ;
  else
    L__=struct ;
  end ;
catch 
  L__=struct ;
end 

if length(varargin)>1,
  
  % assume varargin to have the following structure: varname1, var1, ...
  
  assert(mod(length(varargin),2)==0) ;
  for i=1:2:length(varargin),
    L__.(varargin{i}) = varargin{i+1} ;
  end ;
  
  f=fieldnames(L__) ;
  for i=1:length(f),
    eval(sprintf('%s=L__.%s;', f{i}, f{i})) ;
  end ;
  
  eval(sprintf('save -V7 %s %s', fname__, sprintf('%s ', f{:}))) ;
else
  
  % assume the second argument is a struct
  assert(length(varargin)==1) ;
  
  f = fieldnames(varargin{1}) ;
  for i=1:2:length(f),
    L__.(f{i}) = varargin{1}.(f{i}) ;
  end ;
  
  f=fieldnames(L__) ;
  for i=1:length(f),
    eval(sprintf('%s=L__.%s;', f{i}, f{i})) ;
  end ;
  
  eval(sprintf('save -V7 %s %s', fname__, sprintf('%s ', f{:}))) ;
  
end ;




return

function save_matrix(filen, M, varname, split_size)
%save_matrix(filen, M, varname, split_size)
%split matrix into parts with size of about split_size 
%bytes (1e+8 default) and save them in one file

if nargin<4
  split_size=1e+8;
end

info = whos('M');
num_splits = ceil(info.bytes/split_size);
num_cols = ceil(size(M, 2)/num_splits);

  
  meta.size=size(M);
  meta.num_splits = num_splits;
  mata.name = varname;
  if fexist(filen)
    save_append(filen, 1, 'meta', meta);
  else
    save(filen, 'meta');
  end
  for j=1:num_splits-1
    %eval(sprintf('%s_split_%i = M(:, 1:num_cols);',varname, j));
    var_split__ = M(:, 1:num_cols);
    M(:, 1:num_cols)=[];
    %save(filen, '-append', sprintf('%s_split_%i',varname,j));
    save_append(filen, 1, sprintf('%s_split_%i',varname,j), var_split__);
    clear var_split__
  end
  if isempty(j), j=0; end;
  var_split__ = M; 
  save_append(filen, 1, sprintf('%s_split_%i',varname,j+1), var_split__);

return

function var=load_matrix(filename, varname)
% var=load_matrix(filename, varname)

load(filename, 'meta')
if ~exist('meta')
  load(filename, varname);
  eval(sprintf('var = %s;',varname))
  return
end

var = [] ;
col = 1;
for j=1:meta.num_splits
  %if col>1
  %  assert(~all(var(:,col-1)==-1* ones(meta.size(1),1)))
  %end
  %assert(all(var(:,col)==-1*ones(meta.size(1),1)))
   
  load(filename, sprintf('%s_split_%i',varname,j));
  eval(sprintf('temp = %s_split_%i;',varname,j));

  if j==1,
    if isnumeric(temp)
      var = zeros(meta.size(1), meta.size(2), class(temp));
    else
      var = zeros(meta.size(1), meta.size(2),'uint8');
      var = char(var);
    end
  end ;

  var(:,col:col + size(temp, 2)-1)=temp;
  col = col + size(temp, 2);
end
%assert(~all(var(:,end)==-1* zeros(meta.size(1),1)))

return

function [false_alarms,hits] = calcroc(output,LTE)

assert(all(size(output)==size(LTE))) ;

[ld,idx] = sort(output); 

i=0 ;

hits=1-cumsum(LTE(idx)>0)/sum(LTE > 0) ;
false_alarms=1-cumsum(LTE(idx)<0)/sum(LTE < 0) ;

% Da die Kurve nie alle Negativen als positiven zaehlt, hat
% Falsealarms nie 
% den Wert 1. Cumsum zaehlt das erste Element als negatives, diese
% fehlt bei
%  den False_alarms.
% Daher wird vorne an den Vektor noch eine 1 gehaengt

hits = [1 hits ];
false_alarms = [1 false_alarms];

if nargout<2,
  false_alarms = [false_alarms;hits];
end ;

return

function [score,tp,tdr]=calcrfcscore(output,LT)
% score=calcrfcscore(output,LT)
map=(LT==1) ;
[s,idx]=sort(-output) ; s=-s ;
map=map(idx) ;

tp=cumsum(map)/sum(LT==1) ;
tdr=cumsum(map)./[1:length(map)] ;

t=tp(2:end)-tp(1:end-1) ;
score = sum(0.5*[tdr(1:end-1)+tdr(2:end)].*t) ;



return

function list=who_file(fname) ;
% list=who_file(fname) ;
  
engine = determine_engine() ;
if isequal(engine, 'matlab')
  list=who('-file', fname) ;
else
  L=load(fname) ;
  list=fieldnames(L) ;
end ;

return

function user_name = whoami
% user_name = whoami
  
global whoami_user_name  
  
if isempty(whoami_user_name)
  
  [ret, whoami_user_name]=unix('whoami') ; 
  if ret~=0,
    if keyboard_allowed(),
      keyboard ;
    end ;
    whoami_user_name='unknown' ;
  end ;
end ;

user_name= whoami_user_name ;
idx=find(user_name<30, 1, 'first') ;
user_name = user_name(1:idx-1) ;

return

function A=spzeros(m,n,szmax) ;
% A=spzeros(m,n) ;

if nargin<=1
  A=sparse([],[],[],m,m) ;
  return ;
end 
if nargin<=2
  A=sparse([],[],[],m,n) ;
  return ;
end 
A=sparse([],[],[],m,n,szmax) ;

return

function save_struct(outfile_name, array, arrayname, MAXSIZE)
% save_struct(outfile_name, array[, arrayname])

if nargin<3
  arrayname='array' ;
end ;

if nargin<4, 
  MAXSIZE = 1e9; % about 1Gb
end ;

whosinfo = whos('array');
if whosinfo.bytes > MAXSIZE
  % linearize first, store original size
  dimensions = size(array) ;
  array = reshape(array, 1, prod(dimensions)) ;

  elementsize = whosinfo.bytes/length(array);
  chunklength = round(MAXSIZE/elementsize);
  numvars = ceil(length(array)/chunklength);
  %fprintf('arraysave2 processes %i chunks:', numvars) ;
  for ix = 1:numvars-1
    eval(sprintf('%s%d = array(%d:%d);',arrayname, ix,(ix-1)*chunklength+1, ...
                 ix*chunklength));
    %fprintf('.') ;
  end
  %fprintf('\n') ;
  eval(sprintf('%s%d = array(%d:end);',arrayname, numvars,(numvars-1)*chunklength+1));
  clear array ix ;
  fprintf('save_struct saves %i chunks:', numvars) ;
  save(outfile_name, '-V7', 'chunklength', 'elementsize', 'numvars', 'dimensions') ;
  for ix = 1:numvars
    save(sprintf('%s_%i.mat', outfile_name, ix), '-V7', sprintf('%s%d', arrayname, ix)) ;
    fprintf('.') ;
  end ;
  fprintf('\n') ;
else
  %eval(sprintf('%s=array;', arrayname)) ;
  save_append(outfile_name, 0, arrayname, array) ;
end

return

function array = load_struct(infile_name, arrayname)
% array = load_struct(infile_name, arrayname)
  
if nargin<2,
  arrayname='array' ;
end ;

L_=load(infile_name) ;
if isfield(L_,'numvars')
  fprintf('arrayload2 loads %i chunks:', L_.numvars) ;
  ix=1;
  L=load(sprintf('%s_%i.mat', infile_name, ix), sprintf('%s%d', arrayname, ix)) ;
  eval(sprintf('array = L.%s1;', arrayname)) ;
  fprintf('.') ;
  for ix = 2:L_.numvars
    L=load(sprintf('%s_%i.mat', infile_name, ix), sprintf('%s%d', arrayname, ix)) ;
    if size(array,1) == 1
      array = [array, eval(sprintf('L.%s%d', arrayname, ix))];
    elseif size(array,2) == 1
      array = [array; eval(sprintf('L.%s%d', arrayname, ix))];
    end
    fprintf('.') ;
  end
  fprintf('\n') ;
  if isfield(L_, 'dimensions'),
    array = reshape(array, L_.dimensions) ;
  end ;
else
  eval(sprintf('array=L_.%s;', arrayname)) ;
end

return

function ret=keyboard_allowed()
% ret=keyboard_allowed()
%
% returns 1, if a keyboard command would be allowed

global g_ignore_keyboard
global THIS_IS_A_RPROC_PROCESS  

if isequal(g_ignore_keyboard, 1),
  ret=0 ;
  return ;
end ;

if isequal(THIS_IS_A_RPROC_PROCESS, 1),
  ret=0 ;
  return ;
end ;

ret=1 ;


return

function model=fix_model(model) ;
% model = fix_model(model) ;

model.contents = reorder_fields(model.contents, model.contents_fields) ;
model.lengths = reorder_fields(model.lengths, model.lengths_fields) ;
model.signals = reorder_fields(model.signals, model.signals_fields) ;
model.segments = reorder_fields(model.segments, model.segments_fields) ;

return

function n = reorder_fields(s, fields)
% n = reorder_fields(s, fields)

  if isempty(s),
    n=s ;
    return ;
  end ;

  n=struct ;
  for i=1:length(fields)
    for j=1:length(s) ;
      n(j).(fields{i}) = s(j).(fields{i}) ;
    end ;
  end ;

  remaining = setdiff(fieldnames(s), fields) ;

  if ~isempty(remaining)
    remaining
    error('these fields are unassigned');
  end ;


return

function blocks = fix_blocks(blocks, model) ;
% blocks = fix_blocks(blocks, model) ;

assert(isequal(model, fix_model(model))) ;
w_fields = fieldnames(init_weights(model)) ;

for i=1:length(blocks),
	if isfield(blocks, 'truth')
		for j=1:length(blocks(i).truth),
			blocks(i).truth(j).weights = reorder_fields(blocks(i).truth(j).weights, w_fields) ;
        	end ;
	end
	if isfield(blocks, 'pred')
		for j=1:length(blocks(i).pred),
			blocks(i).pred(j).weights = reorder_fields(blocks(i).pred(j).weights, w_fields) ;
        	end ;
	end
end ;

return

function [xis,parameters,hvar,H,obj] = res2param(res, num_examples, model, QP, C, weight_names)
% [xis,parameters,hvar,H] = res2param(res, num_examples, model)
 

%%%%%% decompose res 

vector = res(1:model.cnt_parameters)' ;
parameters = init_weights(model) ;
param_name = weight_names ;%fieldnames(parameters);
last_pos = 0 ;
for p = 1:length(param_name)
  old_p = getfield(parameters, param_name{p}) ;
  parameters = setfield(parameters, param_name{p}, vector(last_pos+1:last_pos+length(old_p)));
  last_pos = last_pos + length(old_p) ;
end
assert(last_pos==length(vector)) ;


xis = res(model.cnt_parameters+1:model.cnt_parameters+num_examples);
 
hvar = res(model.cnt_parameters+num_examples+1:end);
H = [] ;
obj = struct;
%for i=1:length(model.plif2param{1})
%  H(i).hvar = hvar(model.plif2param{i});
%end


if ~isfield(QP, 'Q')
  return
end

%%%%%% decompose obj 

r = res;
r(1:model.cnt_parameters) = 0;
r(end-length(hvar)+1:end) = 0;
obj.slack = sum(r.*QP.f) ;

r = res;
r(model.cnt_parameters-model.cnt_transitions+1:end) = 0;
obj.plif_ys_sq = 0.5*r'*QP.Q*r;

r = res;
r(1:model.cnt_parameters-model.cnt_transitions) = 0;
r(model.cnt_parameters+1:end) = 0;
obj.transitions_sq = 0.5*r'*QP.Q*r;

r = res;
nof_smooth =(model.cnt_plifs*(model.bins-1))+model.cnt_transitions;% because of trans_smooth
r(1:end-nof_smooth) = 0;
obj.smoothness_sq = 0.5*r'*QP.Q*r;

r(end-model.cnt_transitions+1:end) = 0;
obj.smooth  = sum(r.*QP.f) ;

r = res;
r(1:model.cnt_parameters+num_examples+nof_smooth-model.cnt_transitions) = 0;
obj.transitions = QP.f'*r ;


%%%


obj.OBJ  = obj.slack + obj.smooth + obj.plif_ys_sq + obj.transitions_sq + obj.smoothness_sq + obj.transitions ;

OBJ_total = sum(res.*QP.f) + 0.5*res'*QP.Q*res ;

if (abs(OBJ_total-obj.OBJ)>1e-8)
  OBJ_total-obj.OBJ
  keyboard
  obj.OBJ = OBJ_total 
end ;

%%%

return

function weights=init_weights(model) ;
% weights=init_weights(model) ;

weights = struct;

%%% content detectors
content_names = fieldnames(model.contents) ;
for s = 1:model.cnt_contents,
  weights = setfield(weights, ['contents_' content_names{s}], zeros(1,model.bins));
end

%%% length detectors
length_names = fieldnames(model.lengths) ;
for s = 1:model.cnt_lengths,
  weights = setfield(weights, ['lengths_' length_names{s}], zeros(1,model.bins));
end

%%% signal detectors
signal_names = fieldnames(model.signals) ;
for s = 1:model.cnt_signals,
  weights = setfield(weights, ['signals_' signal_names{s}], zeros(1,model.bins));
end

%%% tiling detectors
if isfield(model, 'tiling')
  tiling_names = fieldnames(model.tiling) ;
  for s = 1:model.cnt_tiling,
    weights = setfield(weights, ['tiling_' tiling_names{s}], zeros(1,model.bins));
  end
end
%%% rna_seq detectors
if isfield(model, 'rna_seq')
  rna_seq_names = fieldnames(model.rna_seq) ;
  for s = 1:model.cnt_rna_seq,
    weights = setfield(weights, ['rna_seq_' rna_seq_names{s}], zeros(1,model.bins));
  end
end
%%% rna_seq_intron_track detectors
if isfield(model, 'rna_seq_intron_track')
  rna_seq_intron_track_names = fieldnames(model.rna_seq_intron_track) ;
  for s = 1:model.cnt_rna_seq_intron_track,
    weights = setfield(weights, ['rna_seq_intron_track_' rna_seq_intron_track_names{s}], zeros(1,model.bins));
  end
end

%%% transitions
weights.transitions = zeros(1,model.cnt_transitions) ;

return

function res = evaluate(fn_blocks, fn_pred_iter, model)

%l = load('/fml/ag-raetsch/share/projects/genefinding/A_thaliana/jonas_new_genes/exp/lsl/tiling_on_Umaps_blocks/train/init.mat');
%l = load('/fml/ag-raetsch/share/projects/genefinding/A_thaliana/jonas_new_genes/exp/lsl/Umaps/train/init.mat');
%l = load('/fml/ag-raetsch/share/projects/genefinding/A_thaliana/jonas_new_genes/exp/lsl/on_Umaps_blocks/train/init.mat');
%l = load('/fml/ag-raetsch/share/projects/genefinding/A_thaliana/jonas_new_genes/exp_new_model/lsl/tiling_old_model/train/init.mat');
%l = load('/fml/ag-raetsch/share/projects/genefinding/A_thaliana/jonas_new_genes/exp_new_model/lsl/abinitio_old_model/train/init.mat');
%PAR1 = l.PAR;
%clear l


%iteration1 = find_iteration(fn_pred);
%l = load(sprintf('%siteration_%i/blocks.mat', PAR1.FN.output_lsl.fn_pred,iteration1)) ;
%blocks1 = load_struct(PAR1.FN.input_lsl.fn_val_blocks, 'blocks');
if ischar(fn_blocks) && ischar(fn_pred_iter),
  blocks1 = load_struct(fn_blocks, 'blocks');

  for j=1:length(blocks1)
    fname = sprintf('%s_viterbi_block%i.mat',fn_pred_iter,blocks1(j).id);
    load(fname,'pred');
    blocks1(j).pred = pred;
    clear pred
  end
else
  blocks1 = fn_blocks ;
  assert(isempty(fn_pred_iter)) ;
end ;
%blocks1 = l.blocks;
%fn_pred_iter = [fn_pred 'iteration_' num2str(iteration1) '/'];

%blocks1([blocks1.strand]=='-')=[];%used for a check
%blocks1([blocks1.strand]=='+')=[];%used for a check
%perm = randperm(length(blocks1));
%blocks1 = blocks1(perm(1:floor(length(blocks1)*7/10)));

  res_all.cds_nucleotides.num_obsv =0; 
  res_all.cds_nucleotides.num_pred =0; 
  res_all.cds_nucleotides.num_corr =0; 
  res_all.cds_exons.num_obsv       =0; 
  res_all.cds_exons.num_pred       =0; 
  res_all.cds_exons.num_corr       =0; 
  res_all.cds_transcripts.num_obsv =0; 
  res_all.cds_transcripts.num_pred =0; 
  res_all.cds_transcripts.num_corr =0; 

%transcripts
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for j=1:length(blocks1)
  segments = blocks1(j).truth(1).segments;
  res_all.cds_transcripts.num_obsv =res_all.cds_transcripts.num_obsv+max(segments(:,4)); 
  if ~isempty(blocks1(j).pred.genes{1})
    res_all.cds_transcripts.num_pred =res_all.cds_transcripts.num_pred+length(blocks1(j).pred.genes); 
  end
  for k=1:max(segments(:,4))
    for l=1:length(blocks1(j).pred.genes)
      if isempty(blocks1(j).pred.genes{1})
        continue;
      end
      trans1 = blocks1(j).pred.genes{l}(blocks1(j).pred.genes{l}(:,3)==model.segments.cds_exon,:);
      trans2 = segments(segments(:,3)==model.segments.cds_exon&segments(:,4)==k,1:3);
      if isequal(trans1,trans2)
         res_all.cds_transcripts.num_corr = res_all.cds_transcripts.num_corr +1;
      end
    end
  end
end

%exons
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for j=1:length(blocks1)
  all_exons1 = [];
  all_exons2 = blocks1(j).truth(1).segments(blocks1(j).truth(1).segments(:,3)==model.segments.cds_exon, 1:3);
  for k=1:length(blocks1(j).pred.genes)
    if isempty(blocks1(j).pred.genes{1})
      continue;
    end
    trans1 = blocks1(j).pred.genes{k}(blocks1(j).pred.genes{k}(:,3)==model.segments.cds_exon,:);
    all_exons1 = [all_exons1;trans1];
  end

  common_exons = intersect(all_exons1, all_exons2, 'rows');
  res_all.cds_exons.num_pred=res_all.cds_exons.num_pred+size(all_exons2,1);
  res_all.cds_exons.num_obsv=res_all.cds_exons.num_obsv+size(all_exons1,1);
  res_all.cds_exons.num_corr=res_all.cds_exons.num_corr+size(common_exons,1);
  if size(common_exons,1)<size(all_exons2,1)
    %keyboard
  end
end


% Compute sensitivity and specificity
%res_all.cds_nucleotides.SN = res_all.cds_nucleotides.num_corr  /res_all.cds_nucleotides.num_obsv;
%res_all.cds_nucleotides.SP = res_all.cds_nucleotides.num_corr  /res_all.cds_nucleotides.num_pred;

res_all.cds_exons.SN       = res_all.cds_exons.num_corr        /res_all.cds_exons.num_obsv;
res_all.cds_exons.SP       = res_all.cds_exons.num_corr        /res_all.cds_exons.num_pred;


res_all.cds_transcripts.SN = res_all.cds_transcripts.num_corr  /res_all.cds_transcripts.num_obsv;
res_all.cds_transcripts.SP = res_all.cds_transcripts.num_corr  /res_all.cds_transcripts.num_pred;
res_all.cds_transcripts.F  = 2*res_all.cds_transcripts.SN*res_all.cds_transcripts.SP/(res_all.cds_transcripts.SP+res_all.cds_transcripts.SN)

res = res_all;

%save(sprintf('%sresults',PAR.fn_pred),'res');

return

return

function print_struct(fid,s)
% print_struct(fid,s)

fields = fieldnames(s);
max_len = 0;
for f=1:length(fields)
  max_len = max(max_len, length(fields{f}));
end

for f=1:length(fields),
  value = getfield(s,fields{f});
  if isempty(value),
    fprintf(fid, '%*s: %s\n',max_len+3,fields{f},'[]');
  elseif iscell(value),
    if size(value,1)==1 & size(value,2)<10,
      if isscalar(value{1}),
        vstr = ['{[' num2str(value{1}) ']'];
        for i=2:size(value,2),
          vstr = [vstr ' [' num2str(value{i}) ']'];
        end
        vstr = [vstr '}'];
      else
        if isempty(value{1}),
          vstr = ['{[]'];
        else
          vstr = ['{[' class(value{1}) ']'];
        end
        for i=2:size(value,2),
          if isempty(value{i}),
            vstr = [vstr ' []'];
          else
            vstr = [vstr ' [' class(value{i}) ']'];
          end
        end
        vstr = [vstr '}'];        
      end
      fprintf(fid, '%*s: %s\n',max_len+3,fields{f},vstr);  
    else
      fprintf(fid, '%*s: %s\n',max_len+3,fields{f},...
              sprintf('{%ix%i cell}',size(value,1),size(value,2)));  
    end
  elseif isstruct(value),
    fprintf(fid, '%*s: %s\n',max_len+3,fields{f},...
            sprintf('[%ix%i struct]',size(value,1),size(value,2)));
  elseif isscalar(value),
    if ischar(value),
      fprintf(fid, '%*s: "%s"\n',max_len+3,fields{f}, value);
    elseif isinteger(value) | mod(value,1)==0,
      fprintf(fid, '%*s: %i\n',max_len+3,fields{f}, value);
    elseif isnumeric(value),
      fprintf(fid, '%*s: %f\n',max_len+3,fields{f}, value);
    else 
      fprintf(fid, '%*s: ...\n',max_len+3,fields{f});     
    end    
  elseif isvector(value),
    if size(value,1)==1 & size(value,2)<10,
      if ischar(value),
        fprintf(fid, '%*s: "%s"\n',max_len+3,fields{f}, value);
      elseif isscalar(value(1)),
        vstr = ['[' num2str(value(1))];
        for i=2:size(value,2),
          vstr = [vstr ' ' num2str(value(i))];
        end
        vstr = [vstr ']'];
      else
        vstr = ['[' class(value(1))];
        for i=2:size(value,2),
          vstr = [vstr ' ' class(value(i))];
        end
        vstr = [vstr ']'];        
      end
      fprintf(fid, '%*s: %s\n',max_len+3,fields{f},vstr);      
    else
      fprintf(fid, '%*s: %s\n',max_len+3,fields{f},...
              sprintf('[%ix%i %s]',size(value,1),size(value,2),class(value)));
    end
  else
    fprintf(fid, '%*s: %s\n',max_len+3,fields{f},...
              sprintf('[%ix%i %s]',size(value,1),size(value,2),class(value)));      
  end
end
return

