#/bin/bash

set -e

hostname
cd $HOME

echo $5
$5

if [ "$1" != 'matlab' -a "$1" != 'octave' ];
then
  echo invalid argument 1, should be either "'"matlab"'" or "'"octave"'" \(provided $1\)
  echo aborting
  false
fi

export MATLAB_RETURN_FILE=`tempfile`

if [ "$1" == 'matlab' ];
then
  $2 -r "`cat $3`" 2>&1 >> $4 || (echo starting Matlab failed; rm -f $MATLAB_RETURN_FILE; exit -1) ;
fi

if [ "$1" == 'octave' ];
then
  $2 --eval "`cat $3`" 2>&1 >> $4 || (echo starting Octave failed; rm -f $MATLAB_RETURN_FILE; exit -1) ;
fi

test -f $MATLAB_RETURN_FILE || exit 0
ret=`cat $MATLAB_RETURN_FILE` ;
rm -f $MATLAB_RETURN_FILE
exit $ret


