%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either version 3 of the License, or
% (at your option) any later version.
%
% Written (W) 2005-2009 Gunnar Raetsch, Gabriele Schweikert, Jonas Behr, Soeren Sonnenburg, Alexander Zien, Georg Zeller, Andre Noll, Cheng Soon Ong, Petra Philips
% Copyright (C) 2005-2009 Max Planck Society and Fraunhofer Institute FIRST 
%
function finish = show_usage(toolname, paramstring, num_param, first_param)
% finish = show_usage(toolname, paramstring, num_param, first_param)

global MGENE_PATH

% then generate usage output
if ischar(paramstring),
  % single usage
  usage_string = gen_usage_string(sprintf('%s(%s)', toolname, paramstring)) ;
  full_usage_string = sprintf('Usage: %s\n   or: %s --help\n\n', usage_string, toolname) ;
else				
  % multiple usage
  for i=1:length(paramstring),
    usage_string{i} = gen_usage_string(sprintf('%s(%s)', toolname, paramstring{i})) ;
  end ;
  full_usage_string = sprintf('Usage: %s\n', usage_string{1}) ;
  for i=2:length(paramstring),
    full_usage_string = [full_usage_string sprintf('   or: %s\n', usage_string{i})] ;
  end ;				  
  full_usage_string = [full_usage_string sprintf('   or: %s --help\n\n', toolname)] ;
end ;

finish = false ;
if num_param==1 && isequal(first_param, '--help'),
  % additionally show tool help

  tmpname = tempname ;
  fd = fopen(tmpname, 'w+') ;
  fprintf(fd, '%s', full_usage_string) ;
  fclose(fd) ;
  system(sprintf('cat %s/doc/%s.txt >> %s && less %s && rm %s', MGENE_PATH, toolname, tmpname, tmpname, tmpname)) ;
  finish = true ;
  return ;
else 
  error(full_usage_string) ;
end ;
